/*
 * $Id: umfloppy.c,v 1.1.1.1 2002/08/16 17:29:27 root Exp $
 * vim:tabstop=8:shiftwidth=8:textwidth=72
 */

#include <assert.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "external_constants.h"
#include "lotol_fdesc.h"

#include "lilo.h"


void
umfloppy_init(void)
{
	char drive;
	char path[32];
	int fd;
	int ret;

	for (drive = 0; drive < MAX_FDS; drive++) {
		/* media */
		sprintf(path, "fd%c/media", '0' + drive);
		fd = open(path, O_RDWR);
		if (fd < 0) {
			/* try again read-only */
			fd = open(path, O_RDONLY);
		}
		if (fd < 0 && errno != ENOENT) {
			fprintf(stderr, "%s: %s: can't open: %s.\n", progname,
					path, strerror(errno));
			exit(1);
		}
		if (fd < 0) {
			/* no such drive */
			continue;
		}
		assert(0 <= fd && fd < FD_LOTOL_MIN);

		ret = dup2(fd, FD_FD_MEDIA(drive));
		assert(ret == FD_FD_MEDIA(drive));

		ret = close(fd);
		assert(0 <= ret);
	}
}

void
umfloppy_shutdown(void)
{
	int drive;

	for (drive = 0; drive < MAX_FDS; drive++) {
		(void) close(FD_FD_MEDIA(drive));
	}
}
