/*
 * $Id: umkbd.c,v 1.1.1.1 2002/08/16 17:29:27 root Exp $
 * vim:tabstop=8:shiftwidth=8:textwidth=72
 */

#include <assert.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/socket.h>

#include "external_constants.h"
#include "lotol_fdesc.h"

#include "lilo.h"
#include "config.h"


void
umkeyboard_init(void)
{
	int fd;
	struct sockaddr_in addr;
	int ret;

	/* create socket */
	fd = socket(PF_INET, SOCK_STREAM, 0);
	assert(0 <= fd && fd < FD_LOTOL_MIN);

	/* connect to keyboard process */
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = htonl(config.keyboard.ipaddr);
	addr.sin_port = htons(config.keyboard.ipport);
	ret = connect(fd, (struct sockaddr *) &addr, sizeof(addr));
	assert(0 <= ret);

	ret = dup2(fd, FD_KEYBOARD);
	assert(FD_KEYBOARD == ret);

	ret = close(fd);
	assert(0 <= ret);
}

void
umkeyboard_shutdown(void)
{
	int ret;

	ret = close(FD_KEYBOARD);
	assert(0 <= ret);
}
