/*
 * $Id: ummem.c,v 1.5 2002/10/22 17:22:25 dunlapg Exp $
 * vim:tabstop=8:shiftwidth=8:textwidth=72
 */

#include <assert.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <asm/page.h>
#include <sys/mman.h>

#include "lotol_fdesc.h"

#include "lilo.h"
#include "config.h"


void
ummem_CPU_init(void)
{
	int ret;

	ret = (int) mmap((char *) MEM_BASE, config.mem_size,
				PROT_READ | PROT_WRITE | PROT_EXEC,
				MAP_SHARED | MAP_FIXED | MAP_LOCKED, 
			        FD_MAIN_MEMORY, 0);
	assert(ret == MEM_BASE);
	fprintf(stderr, "locking memory...\n");
	ret=mlockall(MCL_CURRENT | MCL_FUTURE);
	if(ret<0) {
		perror("mlockall");
	}
}


void
ummem_init(void)
{
	char tmpfile[256];
	int fd;
	unsigned long addr;
	int ret;

	/* create memory file */
	sprintf(tmpfile, "/tmp/page%08x", getpid());
	fd = open(tmpfile, O_RDWR | O_CREAT | O_EXCL, 0700);
	assert(0 <= fd && fd < FD_LOTOL_MIN);

	ret = unlink(tmpfile);
	assert(0 <= ret);

	for (addr = MEM_BASE;
	    addr < MEM_BASE + config.mem_size;
	    addr += PAGE_SIZE) {
		static char zero[PAGE_SIZE];

		ret = write(fd, zero, PAGE_SIZE);
		assert(ret == PAGE_SIZE);
	}

	ret = dup2(fd, FD_MAIN_MEMORY);
	assert(ret == FD_MAIN_MEMORY);

	ret = close(fd);
	assert(0 <= ret);
}

void
ummem_shutdown(void)
{
	int ret;

	ret = close(FD_MAIN_MEMORY);
	assert(0 <= ret);
}
