/*
 * $Id: umrtc.c,v 1.1.1.1 2002/08/16 17:29:27 root Exp $
 */

#include <assert.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>

#include "lotol_fdesc.h"


void
umrtc_CPU_init(void)
{
	int ret;

	ret = (int) mmap((char *) VA_RTC, SZ_RTC,
			PROT_READ | PROT_WRITE,
			MAP_FIXED | MAP_SHARED,
			FD_RTC, 0);
	assert(ret == VA_RTC);
}

void
umrtc_init(void)
{
	char page[SZ_RTC];
	char tmpfile[256];
	int fd;
	int ret;

	sprintf(tmpfile, "rtc%d", getpid());
	fd = open(tmpfile, O_EXCL | O_CREAT | O_RDWR, 0600);
	assert(0 <= fd && fd < FD_LOTOL_MIN);

	ret = unlink(tmpfile);
	assert(0 <= ret);

	ret = write(fd, page, sizeof(page));
	assert(ret == sizeof(page));

	ret = dup2(fd, FD_RTC);
	assert(ret == FD_RTC);

	ret = close(fd);
	assert(0 <= ret);
}

void
umrtc_shutdown(void)
{
	int ret;

	ret = close(FD_RTC);
	assert(0 <= ret);
}
